import React, { useEffect } from "react";
import { Modal, Spin } from "antd";
import { useModalState } from "../../../../../../zustand/Modal";
import FormikForm from "../../../../../../Layout/Dashboard/FormikFormModel";
import ModelBody from "./Add";
import { getInitialValues, getValidationSchema } from "./formUtil";
import { ModalEnum } from "../../../../../../enums/Model";
import { useObjectToEdit } from "../../../../../../zustand/ObjectToEditState";
import { useAddMark } from "../../../../../../api/mark";
import { useMarkState } from "../../../../../../zustand/MarkState";
import { useTranslation } from "react-i18next";

const ModalForm: React.FC = () => {
  const { isOpen, setIsOpen } = useModalState((state) => state);
  const { mutate, isSuccess, isLoading } = useAddMark();
  const { set_object_to_edit } = useObjectToEdit();
  const { HeaderData, setHeaderData } = useMarkState();

  useEffect(() => {
    if (isSuccess) {
      setIsOpen("isSuccess");
      set_object_to_edit({});
      setHeaderData({
        ...HeaderData,
        total_student_count: Number(HeaderData?.total_student_count) + 1,
      });
    }
  }, [isSuccess]);

  console.log(HeaderData, "HeaderData");

  const handleSubmit = (values: any) => {
    const dataToSend = {
      ...values,
      exam_id: HeaderData?.id,
    };

    mutate(dataToSend);
  };

  const handleCancel = () => {
    setIsOpen("");
    set_object_to_edit({});
  };
  const [t] = useTranslation();

  return (
    <>
      <Modal
        className="ModalForm"
        centered
        width={"60vw"}
        footer={null}
        open={isOpen === ModalEnum?.MARK_ADD}
        onCancel={handleCancel}
      >
        <FormikForm
          handleSubmit={handleSubmit}
          initialValues={getInitialValues([])}
          validationSchema={getValidationSchema}
        >
          <header>
            {t("practical.add")} {t("models.mark")}{" "}
          </header>
          <main className="main_modal w-100">
            <ModelBody />
            <div className="buttons">
              <div onClick={handleCancel}>{t("practical.back")}</div>
              <button disabled={isLoading} type="submit">
                {t("practical.add")}
                {isLoading && (
                  <span className="Spinier_Div">
                    <Spin />
                  </span>
                )}
              </button>
            </div>
          </main>
        </FormikForm>
      </Modal>
    </>
  );
};

export default ModalForm;
